	//preferences object
	const prefObj = new prefClass();


	//startup function
	function loadEasyPref()
	{
		parent.hPrefWindow.registerOKCallbackFunc(onApplyButton);
		
		//for categories:
		setCategories();

		var esFixedFontSize = prefObj.getData("integer", "extensions.easysearch.fixedsize");
		if(esFixedFontSize)
		{
			document.getElementById("esFixedStatus").checked = true;
			var esFixedSize = document.getElementById("esFixedSize");
			esFixedSize.disabled = false;

			var selectedObj = document.getElementById('esFixedListSize').getElementsByAttribute("label", esFixedFontSize)[0];
			esFixedSize.selectedItem = selectedObj;
		}
	}

	//setup categories
	function setCategories()
	{
		var xpcomSearch = Components.classes["@mozilla.org/rdf/datasource;1?name=internetsearch"].getService();
		if(xpcomSearch)
		{
			xpcomSearch = xpcomSearch.QueryInterface(Components.interfaces.nsIInternetSearchService);
			var dsCategories = xpcomSearch.GetCategoryDataSource();
		    dsCategories = dsCategories.QueryInterface(Components.interfaces.nsIRDFDataSource);
			
			//v0.98 = use/show Mozilla categories
			if(dsCategories)
			{
				var xulCategories = document.getElementById("categoryListData");
				xulCategories.database.AddDataSource(dsCategories);				
		        var ref = xulCategories.getAttribute("ref");
		        if (ref)  xulCategories.setAttribute("ref", ref);

			}
			else
			{
				showError("Can't load datasource for categories");
			}
			xulCategories.builder.rebuild();

			//load ds in enginePrefList
			var xulEngineList = document.getElementById("enginePrefList");
			xulEngineList.database.AddDataSource(dsCategories);
			xulEngineList.setAttribute("ref", "NC:SearchEngineRoot");
			
			var sIncludes = prefObj.getData("char", "extensions.easysearch.includes");

			if(!sIncludes)
			{
				selectEngines('');			
			}
			else
			{
				//if default category is set	
				var defaultCategory = prefObj.getData("char", "browser.search.last_search_category");
				if(defaultCategory)
				{
					var sPrefix = "NC:SearchCategory?category=";

					if(defaultCategory.indexOf(sPrefix) == 0)
					{
						defaultCategory = defaultCategory.substr(sPrefix.length);
					}

					try
					{
						var defaultNode = xulCategories.getElementsByAttribute("id", defaultCategory)[0];
						if(defaultNode)
						{
							document.getElementById("categoryList").selectedItem = defaultNode;
							selectEngines(defaultNode);
						}
						else
						{
							selectEngines('');
						}
					}
					catch(e)
					{
						showError(e);
					}
				}
			}
		}
		else
		{
			showError("Can't load xpcom obj for internetsearch");
		}

	}
	
	//selectEngines by category
	function selectEngines(selectedCategory)
	{
		var xulEngineList = document.getElementById("enginePrefList");
		var categoryPath = "";

		if(selectedCategory == "")
		{
			categoryPath = "NC:SearchEngineRoot";
		}
		else
		{
			categoryPath = "NC:SearchCategory?category=" + selectedCategory.id;
		}
		xulEngineList.setAttribute("ref", categoryPath);
		xulEngineList.builder.rebuild();
		setEngines();
	}

	//setup includes (from v.098)
	function setEngines()
	{
		loadEngines(document.getElementById("enginePrefList"));
		
		var sIncludes = prefObj.getData("char", "extensions.easysearch.includes");

		if(sIncludes)
		{
			var engineList = returnEngineList();

			for(var i=0; i<engineList.childNodes.length; i++)
			{
				var thisObj = engineList.childNodes.item(i);
				if(!(sIncludes.indexOf("|" + escape(thisObj.getAttribute("label")) + "|") > -1))
				{
					thisObj.checked = false;
				}
			}
		}
	}

	//save function
	function onApplyButton()
	{
		var data = parent.hPrefWindow.wsm.dataManager.pageData["chrome://easysearch/content/pref-easysearch.xul"];
		var listExists = ("returnEngineList" in window);
		var listOfIncludes = "";

		//check if there are any unselected engines in selected category	
		if(listExists && (returnEngineList().childNodes.length > 1))
		{
			var engineList = returnEngineList();

			for(var i=0; i < engineList.childNodes.length; i++)
			{
				if(engineList.childNodes.item(i).checked == true)
				{
					listOfIncludes += "|" + escape(engineList.childNodes.item(i).getAttribute("label"));
				}
			}

			//to make string "|<engine>|<engine>|" AND to set includes valid
			listOfIncludes += "|";
			
			prefObj.setData("char", "extensions.easysearch.includes", listOfIncludes);
		}

		//check if selected category
		var xulCategoryList = document.getElementById("categoryList").selectedItem;
		var rdfSearchCategory = "NC:SearchEngineRoot";
		
		if(xulCategoryList.id) //will be false if View All is selected
		{
			rdfSearchCategory = "NC:SearchCategory?category=" + xulCategoryList.id;
		}

		prefObj.setData("char", "browser.search.last_search_category", rdfSearchCategory);

		var esFixedSize = document.getElementById("esFixedSize");
		//if not disabled save property
		if(!esFixedSize.disabled)
		{
			prefObj.setData("integer", "extensions.easysearch.fixedsize", esFixedSize.selectedItem.getAttribute("label"));
		}
		else //set to nothing
		{
			prefObj.setData("integer", "extensions.easysearch.fixedsize", 0);		
		}
	}
		
	//change status of all engines
	function changeEngineStatus(bStatus)
	{
		var engineList = returnEngineList();
		for(var i = 0; i < engineList.childNodes.length; i++)
		{
			engineList.childNodes.item(i).checked = bStatus;		
		}
	}
	
	//return enginelist
	function returnEngineList()
	{
		return document.getElementById("enginePrefList");
	}

	//setup search
	function loadEngines(engineList)
	{
		var myRdf = Components.classes["@mozilla.org/rdf/rdf-service;1"]
				   .getService(Components.interfaces.nsIRDFService);
		var engineDS = myRdf.GetDataSource("rdf:internetsearch");

		engineList.database.AddDataSource(engineDS);
		engineList.builder.rebuild();
	}
	
	//clear history
	function clearHistory()
	{
		prefObj.setData("char", "extensions.easysearch.history", "");
	}

	//change state of fixed status
	function esFixedSizeStatus(esFixedEnable)
	{
		var esFixedSize = document.getElementById("esFixedSize");

		if(esFixedEnable.checked)
		{
			esFixedSize.disabled = false;
		}
		else
		{
			esFixedSize.disabled = true;
		}
	}