/*********************************
Search class

*********************************/
function searchClass()
{	
	//methods
	this.easyEngine 	= null;
	this.engineType	= null;

	//attributes
	this.setEngine 	= setEngine;
	this.callSearch = callSearch;
	this.startSearch = startSearch;
	this.doLocalSearch = doLocalSearch;
//	this.doDictSearch = doDictSearch;
	
	//set engine
	function setEngine(sEngine, sType)
	{
		this.easyEngine 	= sEngine;
		this.engineType	= sType;
	}
	
	//search on page
	function doLocalSearch(sQuery)
	{
		var browserFinder 	= getBrowser().webBrowserFind;

		var boolMatchCase 	= document.getElementById("checkMatchCase")
						.getAttribute("checked") ? true : false;
		var boolWrap 		= document.getElementById("checkWrap")
						.getAttribute("checked") ? true : false;	
		var boolBackwards 	= document.getElementById("checkBackwards")
						.getAttribute("checked") ? true : false;	

		//save local search
		saveLocalSearch(sQuery, boolMatchCase, boolWrap, boolBackwards);
		try
		{
			//search in page
			findObj = browserFinder.QueryInterface(Components.interfaces.nsIWebBrowserFind);

			//set values
			findObj.searchString  = sQuery;
			findObj.matchCase     = boolMatchCase;
			findObj.wrapFind      = boolWrap;
			findObj.findBackwards = boolBackwards;

			//move next
			var searchResult = findObj.findNext();

			if(!searchResult) // tell user
			{
				alert("The text you entered was not found.");
			}
		}
		catch(e) { showError(e); }
	}

	function callSearch(sQuery, searchWType)
	{
		startSearch(sQuery, searchWType, this.easyEngine);
	}

	
	//start search...
	function startSearch(sQuery, searchWType, searchEngine)
	{
		if(searchEngine == null)
		{
			showError("Searchengine not set!");
			return;
		}
		
		var sUrl = "";

		//search databasource
		var searchDS = Components.classes["@mozilla.org/rdf/datasource;1?name=internetsearch"]
				 .getService(Components.interfaces.nsIInternetSearchService);

		//if datasource exists
		if(searchDS)
		{
			try
			{
				//fix for 0.99+ (added three params)
				sUrl = searchDS.GetInternetSearchURL(searchEngine, sQuery, 0, 0, {value:0});
			}
			catch(e)
			{
				showError(e);
			}	
		}

		//if sidebar should be activated on search
		if(doOpenSideBar())
		{
			//if sidebar is opened, set focus on search and show search results
			var sidebarPanel = document.getElementById("urn:sidebar:panel:search");

			if(sidebarPanel)
			{
				SidebarSelectPanel(sidebarPanel, true, true);	
			}
		}
		
		addToHistory(searchEngine, sQuery);

		// opens in new tab = ctrl pressed
		if(searchWType == 1)
		{

			getBrowser().addTab(sUrl);

			//to get focus on the new tab
			getBrowser().selectedTab = getBrowser().mTabContainer.childNodes[getBrowser().mTabContainer.childNodes.length - 1];

		}//opens in new window = alt pressed
		else if(searchWType == 2)
		{
			window.open(sUrl);
		}
		else //this window
		{
			loadURI(sUrl);		
		}
	}
}